//
//  TableViewController.m
//  custom-uitableviewcell
//
//  Created by Matthew Schettler on 4/18/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "TableViewController.h"

@implementation TableViewController


- (void)viewDidLoad
{
    [super viewDidLoad];

    Movie *m1 = [Movie new];
    m1.YEAR = 2012;
    m1.IMDB_RATING = 9.3;
    m1.TITLE = @"The Best Movie In The World";
    m1.IMDB_URL = @"www.google.com";
    m1.POSTER_NAME = @"noposter";
    m1.PLOT = @"Action";

    Movie *m2 = [Movie new];
    m2.YEAR = 1995;
    m2.IMDB_RATING = 2.3;
    m2.TITLE = @"The Worst Movie In The World";
    m2.IMDB_URL = @"www.google.com";
    m2.POSTER_NAME = @"noposter";
    m2.PLOT = @"Drama";

    
    datasource = [[NSArray alloc] initWithObjects:m1, m2, nil];
    
}

- (int)numberOfSectionsInTableView:(UITableView *)tableView {
    return 1;
}

- (int)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    assert(datasource);
    return datasource.count;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {

    // this is the "black magic" that easily enables us to use custom cell w/ IB
    UITableViewCell *cell = nil;

    CustomCell *temp = [[[CustomCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:nil] autorelease];
    NSArray *topLevelObjects = [[NSBundle mainBundle] loadNibNamed:@"CustomCell" owner:temp options:nil];
    id firstObject = [topLevelObjects objectAtIndex:0];
    if ([firstObject isKindOfClass:[UITableViewCell class]]) {
        cell = firstObject;
    } else {
        cell = [topLevelObjects objectAtIndex:1];
    }

    
    // get associated movie object
    Movie *m = [datasource objectAtIndex:indexPath.row];
    
    // make the cell display the contents of this movie
    [temp loadMovie:m]; 


    
    
    return cell;
    
}

@end
